Macro Geneva Wheel GUI: Difference between revisions

From FreeCAD Documentation
No edit summary
(nowiki to guard)
 
(30 intermediate revisions by 5 users not shown)
Line 1: Line 1:
<languages/>
{{Macro|Icon=Text-x-python|Name=MacroGeneva_Wheel_GUI|Description=A GUI front end that allows the user to create a Geneva wheel mechanism from scratch. Based on drei's Geneva Wheel Macro|Author=quick61}}
<translate>
<!--T:1-->
{{Macro
|Name=Geneva Wheel GUI
|Icon=GW_Dim.png
|Description=A GUI front end that allows the user to create a Geneva wheel mechanism from scratch. Based on drei's [[Macro Geneva Wheel|Macro Geneva Wheel]]
|Author=quick61
|Version=1.0
|Date=2014-09-21
|FCVersion=All
|Download=[https://www.freecadweb.org/wiki/images/8/8d/GW_Dim.png ToolBar Icon]
}}


==Description== <!--T:10-->
To use this Macro, copy to your FreeCAD Macro directory and include the graphic image [http://www.freecadweb.org/wiki/images/8/8d/GW_Dim.png GW_Dim.png] in the same directory as the Macro.


<!--T:11-->
[[File:Http://www.freecadweb.org/wiki/images/d/df/New GW GUI.png|center|Screenshot of Macro and result.]]
A GUI front end that allows the user to create a Geneva wheel mechanism from scratch. Based on drei's [[Macro Geneva Wheel|Macro Geneva Wheel]]


==How To Use== <!--T:2-->
<syntaxhighlight>

<!--T:3-->
To use this Macro, copy it to your FreeCAD Macro directory and include the icon graphic in the same directory as the Macro.

<!--T:4-->
[[File:GW_Dim.png]]
{{Caption|Copy and include this graphic with the macro.}}

==Screenshot== <!--T:5-->

<!--T:6-->
[[File:New GW GUI.png|Screenshot of Macro and result.]]

==Script== <!--T:7-->
</translate>

ToolBar Icon [[Image:GW_Dim.png]]

'''Macro_Geneva_Wheel_GUI.FCMacro'''

{{MacroCode|code=
<nowiki>
#Creation of a Geneva Wheel with Parametric values By: Isaac Ayala (drei) & Mark Stephen (quick61)
#Creation of a Geneva Wheel with Parametric values By: Isaac Ayala (drei) & Mark Stephen (quick61)
#This Macro creates the main parts of a Geneva Wheel Mechanism
#This Macro creates the main parts of a Geneva Wheel Mechanism
Line 16: Line 51:
#a = Drive Crank Radius
#a = Drive Crank Radius
#b = Geneva Wheel Radius
#b = Geneva Wheel Radius
#n = Driven Slot Quantity
#p = Drive Pin Radius
#p = Drive Pin Radius
#t = Geneva Wheel Tolerance
#t = Geneva Wheel Tolerance
#h = Geneva Wheel Height
#h = Geneva Wheel Height
#n = Driven Slot Quantity
# Output
# Output
#c = Distance Between Centers
#c = Distance Between Centers
Line 47: Line 82:




def Ggear(self):
def Ggear(self):


try:
try:
#Inputs
#Inputs
a = float(self.dCr.text())
a = float(self.dCr.text())
b = float(self.gWr.text())
#b = float(self.gWr.text())
n = int(self.dSq.text())
p = float(self.dPd.text())
p = float(self.dPd.text())
t = float(self.gWt.text())
t = float(self.gWt.text())
h = float(self.gWh.text())
h = float(self.gWh.text())
n = float(self.gWn.text())


#Outputs
#Outputs
c = math.sqrt(pow(a,2) + pow(b,2))
#c = math.sqrt(pow(a,2) + pow(b,2))
c = a/math.sin(math.pi/n)
s = a + b - c
b = math.sqrt((math.pow(c,2))-(math.pow(a,2)))
w = p + t
y = a - (1.5 * p)
s = a + b - c
z = y - t
w = p + t
v = (b * z)/a
y = a - (3 * p)
z = y - t
v = (b * z)/a
m = math.sqrt((v**2)+(z**2)) # Solves for location of clearance cut axis


# Create the Drive Crank (Will be placed on the origin)
# Create the Drive Crank (Will be placed on the origin)
driveCrank = Part.makeCylinder(z, h)
driveCrank = Part.makeCylinder(z, h)
driveCrank.translate(Base.Vector(0,0,0))
#driveCrank.translate(Base.Vector(0,0,0))


genevaWheelClearanceCut = Part.makeCylinder(b, h)
#genevaWheelClearanceCut = Part.makeCylinder(b, h)
genevaWheelClearanceCut.translate(Base.Vector(-c,0,0))
#genevaWheelClearanceCut.translate(Base.Vector(-c,0,0))


genevaWheelClearanceCut = Part.makeCylinder(v, h)
driveCrank = driveCrank.cut(genevaWheelClearanceCut)
genevaWheelClearanceCut.translate(Base.Vector(-m,0,0))


driveCrank = driveCrank.cut(genevaWheelClearanceCut)
driveCrankBase = Part.makeCylinder((2*a), h)
driveCrankBase.translate(Base.Vector(0,0,-h))


driveCrankBase = Part.makeCylinder((a+(2*p)), h)
driveCrank = driveCrank.fuse(driveCrankBase)
driveCrankBase.translate(Base.Vector(0,0,-h))


driveCrank = driveCrank.fuse(driveCrankBase)
drivePin = Part.makeCylinder(p,h)
drivePin.translate(Base.Vector(-a,0,0))


drivePin = Part.makeCylinder(p,h)
driveCrank = driveCrank.fuse(drivePin)
drivePin.translate(Base.Vector(-a,0,0))


driveCrank = driveCrank.fuse(drivePin)
# Create the Geneva Wheel (Will be placed on the x-axis on the left side)
genevaWheel = Part.makeCylinder(b,h)
genevaWheel.translate(Base.Vector(-c,0,0))


# Create the Geneva Wheel (Will be placed on the x-axis on the left side)
stopArc = Part.makeCylinder(y, h)
genevaWheel = Part.makeCylinder(b,h)
stopArc.translate(Base.Vector(((y-(b/2)),0,0)))
stopArc.rotate(Base.Vector(-c,0,0),Base.Vector(0,0,1),30)
genevaWheel.translate(Base.Vector(-c,0,0))


stopArc = Part.makeCylinder(y, h)
for i in range(6):
stopArc.rotate(Base.Vector(-c,0,0),Base.Vector(0,0,1),60)
stopArc.rotate(Base.Vector(-c,0,0),Base.Vector(0,0,1),(180/n))
genevaWheel = genevaWheel.cut(stopArc)


for i in range(int(n)):
#genevaWheel = genevaWheel.cut(Draft.makeArray(FreeCAD.ActiveDocument.stopArc, Base.Vector(-c,0,0), 360, n))
stopArc.rotate(Base.Vector(-c,0,0),Base.Vector(0,0,1),(360/n))
genevaWheel = genevaWheel.cut(stopArc)


slotLength = Part.makeBox(s,(2*w),h)
slotLength = Part.makeBox(s,(2*w),h)
slotLength.translate(Base.Vector(-a,-w,0))
slotLength.translate(Base.Vector(-a,-w,0))


slotRadius = Part.makeCylinder(w,h)
slotRadius = Part.makeCylinder(w,h)
slotRadius.translate(Base.Vector(-a,0,0))
slotRadius.translate(Base.Vector(-a,0,0))


slot=slotLength.fuse(slotRadius)
slot=slotLength.fuse(slotRadius)


for i in range(6):
for i in range(int(n)):
slot.rotate(Base.Vector(-c,0,0),Base.Vector(0,0,1),60)
slot.rotate(Base.Vector(-c,0,0),Base.Vector(0,0,1),(360/n))
genevaWheel = genevaWheel.cut(slot)
genevaWheel = genevaWheel.cut(slot)


# Display Result
#genevaWheel = genevaWheel.cut(Draft.makeArray(FreeCAD.ActiveDocument.slot, Base.Vector(-c,0,0), 360, n))


Part.show(driveCrank)
Part.show(genevaWheel)


# Display Result
except:
FreeCAD.Console.PrintError("Unable to complete task. Please recheck your data entries.")


self.close()
Part.show(driveCrank)
#Part.show(genevaWheelClearanceCut)
Part.show(genevaWheel)
#Part.show(stopArc)
#Part.show(slot)


def close(self):
except:
self.dialog.hide()
FreeCAD.Console.PrintError("Unable to complete task. Please recheck your data entries.")


def __init__(self):
self.close()
self.dialog = None


self.dialog = QtGui.QDialog()
def close(self):
self.dialog.hide()
self.dialog.resize(240,100)


self.dialog.setWindowTitle("Geneva Wheel Macro")
def __init__(self):
la = QtGui.QVBoxLayout(self.dialog)
self.dialog = None


DCR = QtGui.QLabel("Drive Crank Radius ( A )")
self.dialog = QtGui.QDialog()
la.addWidget(DCR)
self.dialog.resize(240,100)
self.dCr = QtGui.QLineEdit()
la.addWidget(self.dCr)


self.dialog.setWindowTitle("Geneva Wheel Macro")
#GWR = QtGui.QLabel("Geneva Wheel Radius ( B )")
#la.addWidget(GWR)
la = QtGui.QVBoxLayout(self.dialog)
#self.gWr = QtGui.QLineEdit()
#la.addWidget(self.gWr)


DCR = QtGui.QLabel("Drive Crank Radius ( A )")
DPD = QtGui.QLabel("Drive Pin Radius ( C )")
la.addWidget(DCR)
la.addWidget(DPD)
self.dCr = QtGui.QLineEdit()
self.dPd = QtGui.QLineEdit()
la.addWidget(self.dCr)
la.addWidget(self.dPd)


GWR = QtGui.QLabel("Geneva Wheel Radius ( B )")
GWT = QtGui.QLabel("Geneva Wheel Tolerance ( D )")
la.addWidget(GWR)
la.addWidget(GWT)
self.gWr = QtGui.QLineEdit()
self.gWt = QtGui.QLineEdit()
la.addWidget(self.gWr)
la.addWidget(self.gWt)


DSQ = QtGui.QLabel("Driven Slot Quantity ( C )")
GWH = QtGui.QLabel("Geneva Wheel Height")
la.addWidget(DSQ)
la.addWidget(GWH)
self.dSq = QtGui.QLineEdit()
self.gWh = QtGui.QLineEdit()
la.addWidget(self.dSq)
la.addWidget(self.gWh)


DPD = QtGui.QLabel("Drive Pin Raidus ( D )")
GWN = QtGui.QLabel("Driven Slot Quantity")
la.addWidget(DPD)
la.addWidget(GWN)
self.dPd = QtGui.QLineEdit()
self.gWn = QtGui.QLineEdit()
la.addWidget(self.dPd)
la.addWidget(self.gWn)


#
GWT = QtGui.QLabel("Geneva Wheel Tolerance ( E )")
# - Include graphic image in dialog window -
la.addWidget(GWT)
#
self.gWt = QtGui.QLineEdit()
# Insure that image is in the same directory as this Macro.
la.addWidget(self.gWt)
# Image should be available from same source as Macro.

#
GWH = QtGui.QLabel("Geneva Wheel Height")
la.addWidget(GWH)
self.gWh = QtGui.QLineEdit()
la.addWidget(self.gWh)

#
# - Include graphic image in dialog window -
#
# Insure that image is in the same directory as this Macro.
# Image should be available from same source as Macro.
#
import os
import os
macro_dir = os.path.dirname(__file__)
macro_dir = os.path.dirname(__file__)
self.PiX = QtGui.QLabel()
self.PiX = QtGui.QLabel()
self.PiX.setPixmap(os.path.join(macro_dir, "GW_Dim.png"))
self.PiX.setPixmap(os.path.join(macro_dir, "GW_Dim.png"))


hbox = QtGui.QHBoxLayout()
hbox = QtGui.QHBoxLayout()
hbox.addStretch()
hbox.addStretch()
hbox.addWidget(self.PiX)
hbox.addWidget(self.PiX)
hbox.addStretch()
hbox.addStretch()
la.addSpacing(15)
la.addSpacing(15)
la.addLayout(hbox)
la.addLayout(hbox)
la.addSpacing(15)
la.addSpacing(15)


# - End Image layout -
# - End Image layout -


okbox = QtGui.QDialogButtonBox(self.dialog)
okbox = QtGui.QDialogButtonBox(self.dialog)
okbox.setOrientation(QtCore.Qt.Horizontal)
okbox.setOrientation(QtCore.Qt.Horizontal)
okbox.setStandardButtons(QtGui.QDialogButtonBox.Cancel|QtGui.QDialogButtonBox.Ok)
okbox.setStandardButtons(QtGui.QDialogButtonBox.Cancel|QtGui.QDialogButtonBox.Ok)
la.addWidget(okbox)
la.addWidget(okbox)
QtCore.QObject.connect(okbox, QtCore.SIGNAL("accepted()"), self.Ggear)
QtCore.QObject.connect(okbox, QtCore.SIGNAL("accepted()"), self.Ggear)
QtCore.QObject.connect(okbox, QtCore.SIGNAL("rejected()"), self.close)
QtCore.QObject.connect(okbox, QtCore.SIGNAL("rejected()"), self.close)
QtCore.QMetaObject.connectSlotsByName(self.dialog)
QtCore.QMetaObject.connectSlotsByName(self.dialog)
self.dialog.show()
self.dialog.show()
self.dialog.exec_()
self.dialog.exec_()


p()
p()
</nowiki>
</syntaxhighlight>
}}

<translate>

==Links== <!--T:8-->

<!--T:9-->
This Macro is based on [[Macro Geneva Wheel|Macro Geneva Wheel]]
</translate>
{{clear}}

Latest revision as of 02:36, 8 May 2020

Other languages:

Geneva Wheel GUI

Description
A GUI front end that allows the user to create a Geneva wheel mechanism from scratch. Based on drei's Macro Geneva Wheel

Macro version: 1.0
Last modified: 2014-09-21
FreeCAD version: All
Download: ToolBar Icon
Author: quick61
Author
quick61
Download
ToolBar Icon
Links
Macro Version
1.0
Date last modified
2014-09-21
FreeCAD Version(s)
All
Default shortcut
None
See also
None

Description

A GUI front end that allows the user to create a Geneva wheel mechanism from scratch. Based on drei's Macro Geneva Wheel

How To Use

To use this Macro, copy it to your FreeCAD Macro directory and include the icon graphic in the same directory as the Macro.

Copy and include this graphic with the macro.

Screenshot

Screenshot of Macro and result.

Script

ToolBar Icon

Macro_Geneva_Wheel_GUI.FCMacro

#Creation of a Geneva Wheel with Parametric values  By: Isaac Ayala (drei) & Mark Stephen (quick61)
#This Macro creates the main parts of a Geneva Wheel Mechanism 

#It depends on six values that must be altered in the following code
#The variables are a, b, n, p, t and h.

#Definition for each variable
#    Input
#a = Drive Crank Radius
#b = Geneva Wheel Radius
#p = Drive Pin Radius
#t = Geneva Wheel Tolerance
#h = Geneva Wheel Height 
#n = Driven Slot Quantity
#    Output
#c = Distance Between Centers
#s = Slot Center Width
#w = Slot Width
#y = Stop Arc Radius
#z = Stop Disc Radius
#v = Clearance Arc

#Please note that you can alter the code so it depends on five values exclusively
#Just replace c, and either a or b with the following
#    Keep value for a
#c = a/math.sin(math.pi/n)
#b = math.sqrt((math.pow(c,2))-(math.pow(a,2)))
#    Keep value for b
#c = b/math.cos(math.pi/n)
#a = math.sqrt((math.pow(c,2))-(math.pow(b,2)))

from __future__ import division
import math
from FreeCAD import Base
from PySide import QtGui, QtCore
from PySide.QtGui import QApplication, QDialog, QMainWindow
import Part
import Draft
class p():


   def Ggear(self):

      try:
         #Inputs
         a = float(self.dCr.text())
         #b = float(self.gWr.text())
         p = float(self.dPd.text())
         t = float(self.gWt.text())
         h = float(self.gWh.text())
         n = float(self.gWn.text())

         #Outputs
         #c = math.sqrt(pow(a,2) + pow(b,2))
         c = a/math.sin(math.pi/n)
         b = math.sqrt((math.pow(c,2))-(math.pow(a,2)))
         s = a + b - c
         w = p + t
         y = a - (3 * p)
         z = y - t
         v = (b * z)/a
         m = math.sqrt((v**2)+(z**2)) # Solves for location of clearance cut axis

         #    Create the Drive Crank (Will be placed on the origin)
         driveCrank = Part.makeCylinder(z, h)
         #driveCrank.translate(Base.Vector(0,0,0))

         #genevaWheelClearanceCut = Part.makeCylinder(b, h)
         #genevaWheelClearanceCut.translate(Base.Vector(-c,0,0))

         genevaWheelClearanceCut = Part.makeCylinder(v, h)
         genevaWheelClearanceCut.translate(Base.Vector(-m,0,0))

         driveCrank = driveCrank.cut(genevaWheelClearanceCut)

         driveCrankBase = Part.makeCylinder((a+(2*p)), h)
         driveCrankBase.translate(Base.Vector(0,0,-h))

         driveCrank = driveCrank.fuse(driveCrankBase)

         drivePin = Part.makeCylinder(p,h)
         drivePin.translate(Base.Vector(-a,0,0))

         driveCrank = driveCrank.fuse(drivePin)

         #    Create the Geneva  Wheel (Will be placed on the x-axis on the left side)
         genevaWheel = Part.makeCylinder(b,h)
         genevaWheel.translate(Base.Vector(-c,0,0))

         stopArc = Part.makeCylinder(y, h)
         stopArc.rotate(Base.Vector(-c,0,0),Base.Vector(0,0,1),(180/n))

         for i in range(int(n)):
            stopArc.rotate(Base.Vector(-c,0,0),Base.Vector(0,0,1),(360/n))
            genevaWheel = genevaWheel.cut(stopArc)

         slotLength = Part.makeBox(s,(2*w),h)
         slotLength.translate(Base.Vector(-a,-w,0))

         slotRadius = Part.makeCylinder(w,h)
         slotRadius.translate(Base.Vector(-a,0,0))

         slot=slotLength.fuse(slotRadius)

         for i in range(int(n)):
            slot.rotate(Base.Vector(-c,0,0),Base.Vector(0,0,1),(360/n))
            genevaWheel = genevaWheel.cut(slot)

         #    Display Result

         Part.show(driveCrank)
         Part.show(genevaWheel)

      except:
         FreeCAD.Console.PrintError("Unable to complete task. Please recheck your data entries.")

      self.close()

   def close(self):
      self.dialog.hide()

   def __init__(self):
      self.dialog = None

      self.dialog = QtGui.QDialog()
      self.dialog.resize(240,100)

      self.dialog.setWindowTitle("Geneva Wheel Macro")
      la = QtGui.QVBoxLayout(self.dialog)

      DCR = QtGui.QLabel("Drive Crank Radius ( A )")
      la.addWidget(DCR)
      self.dCr = QtGui.QLineEdit()
      la.addWidget(self.dCr)

      #GWR = QtGui.QLabel("Geneva Wheel Radius ( B )")
      #la.addWidget(GWR)
      #self.gWr = QtGui.QLineEdit()
      #la.addWidget(self.gWr)

      DPD = QtGui.QLabel("Drive Pin Radius ( C )")
      la.addWidget(DPD)
      self.dPd = QtGui.QLineEdit()
      la.addWidget(self.dPd)

      GWT = QtGui.QLabel("Geneva Wheel Tolerance ( D )")
      la.addWidget(GWT)
      self.gWt = QtGui.QLineEdit()
      la.addWidget(self.gWt)

      GWH = QtGui.QLabel("Geneva Wheel Height")
      la.addWidget(GWH)
      self.gWh = QtGui.QLineEdit()
      la.addWidget(self.gWh)

      GWN = QtGui.QLabel("Driven Slot Quantity")
      la.addWidget(GWN)
      self.gWn = QtGui.QLineEdit()
      la.addWidget(self.gWn)

      #
      # - Include graphic image in dialog window - 
      #
      # Insure that image is in the same directory as this Macro.
      # Image should be available from same source as Macro.
      #
  
      import os
      macro_dir = os.path.dirname(__file__)
      self.PiX = QtGui.QLabel()
      self.PiX.setPixmap(os.path.join(macro_dir, "GW_Dim.png"))

      hbox = QtGui.QHBoxLayout()
      hbox.addStretch()
      hbox.addWidget(self.PiX)
      hbox.addStretch()
      
      la.addSpacing(15)
      la.addLayout(hbox)
      la.addSpacing(15)

      # - End Image layout -

      okbox = QtGui.QDialogButtonBox(self.dialog)
      okbox.setOrientation(QtCore.Qt.Horizontal)
      okbox.setStandardButtons(QtGui.QDialogButtonBox.Cancel|QtGui.QDialogButtonBox.Ok)
      la.addWidget(okbox)
      QtCore.QObject.connect(okbox, QtCore.SIGNAL("accepted()"), self.Ggear)
      QtCore.QObject.connect(okbox, QtCore.SIGNAL("rejected()"), self.close)
      QtCore.QMetaObject.connectSlotsByName(self.dialog)
      self.dialog.show()
      self.dialog.exec_()

p()


Links

This Macro is based on Macro Geneva Wheel